class filelist(list):
    # This class has methods for printing newline-terminated string items from its 'self'.
    # so that 'print' my be used to redirect the lists contents to a file.

    def __init__(self, item = None):
        list.__init__([])
        if item:
            self.append(item)

    def __str__(self):
#        if self:
        return ''.join(line for line in self)
#        return '[]'

    def __repr__(self):
        return str(type(self))

    def reset(self):
        del self[:]

class testfilelist(filelist):
    def __init__(self):
        list.__init__([])
        testfile = open('BUF32.ASM')
        for line in testfile:
            self.append(line)

class autolist(list):
    # This class is experimental! prints and reprs are kind of cool.

    def __init__(self, item = None):
        list.__init__([])
        if item:
            self.append(item)

    def __repr__(self):
        return str(type(self))

    def __str__(self):
        if self:
            return '[\n' + '\n'.join(str(line) for line in self) + '\n]'
        return list.__repr__(self)

    def __iadd__(self, item):
        temp = []
        temp.append(str(item))
        return autolist(self + temp)

    def add(self, item):
        self.append(item)
