def convert(fname):
    listing = []
    try:
        infile = open(fname)
        for line in infile:
            if line[0] == '*' or line[0] == '\n':
                listing.append(line)
                continue
            label, line = Rem1Word(line)
            if not line:
                listing.append(label + '\n')
                continue
            label  += '\t'
            mne, line = Rem1Word(line)
            if not line:
                mne  += '\n'
                operand = ''
            else:
                mne  += '\t'
                if line[:1] == '\'':
                    operand = ''
                else:
                    operand, line = Rem1Word(line)
                    if line:
                        operand  += ('\t' * (1+(len(operand)<8)))
                    else:
                        operand  += '\n'
            line = label + mne + operand + line
            listing.append(line)
        outfile = open(fname+'bc', 'w')
        outfile.writelines(listing)
        outfile.close()
    finally:
        if infile:
            infile.close()

def Rem1Word(string):       # Remove 1 word from the begining of string;
    if not string or type(string) != str:
        return '', ''
    s=''
    for i, a in enumerate(string):
        if a.isspace(): break
        s += a
    return s, string[i + 1:].lstrip(' \t')





if __name__ == "__main__":
    convert('bigtest.asm')
